# Handling Case Insensitive Duplicated User Details

In the registration processor, there was an issue where packets were failing at the supervisor validation stage when the username of the supervisor was entered in a different case than it appeared in the database. To resolve this issue, a case insensitive search will be implemented to retrieve the username of the supervisor during the validation stage.

In order for this fix to work properly, it is necessary for the `user_id` column of the `user_details` table in the master database to not contain any case insensitive duplicates.

If there are any duplicates in this table, packets will fail at the supervisor validation stage once again. Therefore, it is important to deactivate or delete these case insensitive duplicates. It should be noted that this action will not have any impact on other areas, as the mapping between keycloak users and the `user_id` of the `user_details` table is one-to-one and case insensitive.

## How can we identify case-insensitive duplicates in the `user_id` column of the `user_details` table?

Follow these steps:

1. Log in to the master schema of the `mosip_master` database.
2. Open a query tool.
3. Execute the following SQL command in the query tool:

   ```
   SELECT lowerid, cnt from (SELECT count(*) as cnt,LOWER(id) as lowerid FROM master.user_detail group by lowerid) t1 where cnt>1 ;
   ```

   Make sure to copy the output to a text file to manage the duplicate data effectively.

## How to deactivate/delete the case insensitive duplicates?

1. Login in to the [admin portal](https://docs.mosip.io/1.2.0/modules/administration/admin-portal-user-guide) with a user having `ZONAL_ADMIN` role.
2. On the left pane, click on `Resources` in the side-menu.

   ![](/files/Uuh7y4MeHixtpiTocYBM)
3. Select `User Center Mapping` under Resources in the side-menu.

   ![](/files/uch9DLMgXJiugwG1OoTH)
4. Click **Filter** on the `User Center Mapping` page.

   ![](/files/dT7VB7ttdK51hRLXg7rF)
5. Enter the `user_id` that was retrieved from the database and copied into the text file. After entering the `user_id`, click on the **Apply** button.

   ![](/files/HnbKdcHOsM72ZNn2KPiS)

   * Now, on the `User Center Mapping` page, case insensitive duplicates of `user_id` would be displayed.
   * Based on the Center, choose the entry that can be deactivated/deleted.
   * Now click on the ellipsis of the selected entry.

   ![](/files/bt0wEznSdpgqCawJUsxf)
6. Select the appropriate action (Delete/ Deactivate) on that entry.

   ![](/files/KY3zMHP6t7701TBT4HVN)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.mosip.io/1.2.0/setup/upgrade/upgrade-runbook/mock-services/upgrade-handling-case-insensitive-duplicates.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
